Subject: Re: [PATCH net-next v2 1/3] drop_monitor: Implement namespace filtering/reporting for software drops

From: Ido Schimmel <[email-masked]>
Date: Wed, 23 Nov 2022 20:10:14 +0200

On Wed, Nov 23, 2022 at 05:21:23PM +0200, nb wrote:
> 
> 
> On 23.11.22 г. 17:16 ч., Ido Schimmel wrote:
> > On Wed, Nov 23, 2022 at 04:28:15PM +0200, Nikolay Borisov wrote:
> > >   static void trace_drop_common(struct sk_buff *skb, void *location)
> > >   {
> > >   	struct net_dm_alert_msg *msg;
> > > @@ -219,7 +233,11 @@ static void trace_drop_common(struct sk_buff *skb, void *location)
> > >   	int i;
> > >   	struct sk_buff *dskb;
> > >   	struct per_cpu_dm_data *data;
> > > -	unsigned long flags;
> > > +	unsigned long flags, ns_id = 0;
> > > +
> > > +	if (skb->dev && net_dm_ns &&
> > > +	    dev_net(skb->dev)->ns.inum != net_dm_ns)
> > 
> > I don't think this is going to work, unfortunately. 'skb->dev' is in a
> > union with 'dev_scratch' so 'skb->dev' does not necessarily point to a
> > valid netdev at all times. It can explode when dev_net() tries to
> > dereference it.
> > 
> > __skb_flow_dissect() is doing something similar, but I believe there the
> > code paths were audited to make sure it is safe.
> > 
> > Did you consider achieving this functionality with a BPF program
> > attached to skb::kfree_skb tracepoint? I believe BPF programs are run
> > with page faults disabled, so it should be safe to attempt this there.
> 
> How would that be different than the trace_drop_common which is called as
> part of the trace_kfree_skb, as it's really passed as trace point probe via:

Consider this call path:

__udp_queue_rcv_skb()
    __udp_enqueue_schedule_skb()
        udp_set_dev_scratch() // skb->dev is not NULL, but not a pointer to a netdev either
	// error is returned
    kfree_skb_reason() // probe is called

dev_net(skb->dev) in the probe will try to dereference skb->dev and
crash.

On the other hand, a BPF program that is registered as another probe on
the tracepoint will access the memory via bpf_probe_read_kernel(), which
will try to safely read the memory and return an error if it can't. You
can do that today without any kernel changes.